Imports RSToolKit.ReportService

Public Class ReportServer

#Region "- Private Variablen - "

    Private strWSURL As String = Nothing
    Private strWSUsername As String = Nothing
    Private strWSPassword As String = Nothing
    Private strWSDomain As String = Nothing
    Private bWSIntegratedSecurity As Boolean = False
    Private strDBServer As String = Nothing
    Private strDBDatabase As String = Nothing
    Private strDBUsername As String = Nothing
    Private strDBPassword As String = Nothing
    Private bDBIntegratedSecurity As Boolean = False
    Public ws As New ReportService.ReportingService2005

#End Region

    Public Property WebServiceURL() As String
        Get
            Return strWSURL
        End Get
        Set(ByVal value As String)
            Me.strWSURL = value
        End Set
    End Property

    Public Property WebServiceUsername() As String
        Get
            Return Me.strWSUsername
        End Get
        Set(ByVal value As String)
            Me.strWSUsername = value
        End Set
    End Property

    Public Property WebServicePassword() As String
        Get
            Return Me.strWSPassword
        End Get
        Set(ByVal value As String)
            Me.strWSPassword = value
        End Set
    End Property

    Public Property WebServiceDomain() As String
        Get
            Return Me.strWSDomain
        End Get
        Set(ByVal value As String)
            Me.strWSDomain = value
        End Set
    End Property

    Public Property WebServiceIntegratedSecurity() As Boolean
        Get
            Return Me.bWSIntegratedSecurity
        End Get
        Set(ByVal value As Boolean)
            Me.bWSIntegratedSecurity = value
        End Set
    End Property

    Public ReadOnly Property ReportServerEdition() As String
        Get
            Return Me.ws.ServerInfoHeaderValue.ReportServerEdition
        End Get
    End Property

    Public ReadOnly Property ReportServerVersionNumber() As String
        Get
            Return Me.ws.ServerInfoHeaderValue.ReportServerVersionNumber
        End Get
    End Property

    Public ReadOnly Property SessionID() As String
        Get
            'Return Me.ws.SessionHeaderValue.SessionId
            Return Nothing
        End Get
    End Property

    Public ReadOnly Property SoapVersion() As String
        Get
            Return Me.ws.SoapVersion.ToString
        End Get
    End Property

    Public ReadOnly Property TimeOut() As String
        Get
            Return Me.ws.Timeout
        End Get
    End Property

    Public ReadOnly Property URL() As String
        Get
            Return Me.ws.Url
        End Get
    End Property

    ''' <summary>
    ''' Return the URI of the current ReportServer
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public ReadOnly Property URI() As Uri
        Get
            Return New Uri(Me.ws.Url)
        End Get
    End Property

    Public ReadOnly Property UserAgent() As String
        Get
            Return Me.ws.UserAgent
        End Get
    End Property

    Public ReadOnly Property ConnectionGroupName() As String
        Get
            Return Me.ws.ConnectionGroupName
        End Get
    End Property

    Public ReadOnly Property EnableDecompression() As Boolean
        Get
            Return Me.ws.EnableDecompression
        End Get
    End Property

    Public ReadOnly Property PreAuthenticate() As Boolean
        Get
            Return Me.ws.PreAuthenticate
        End Get
    End Property

    Public ReadOnly Property ClientCertificates() As System.Security.Cryptography.X509Certificates.X509CertificateCollection
        Get
            Return Me.ws.ClientCertificates
        End Get
    End Property

    Public ReadOnly Property Path() As String
        Get
            Return "/"
        End Get
    End Property

    Public Sub New(ByVal WebServiceURL As String, ByVal IntegratedSecurity As Boolean, Optional ByVal WSUSername As String = Nothing, Optional ByVal WSPassword As String = Nothing, Optional ByVal WSDomain As String = Nothing)
        Me.strWSURL = WebServiceURL
        Me.WebServiceUsername = WSUSername
        Me.WebServicePassword = WSPassword
        Me.WebServiceDomain = WSDomain
        Me.WebServiceIntegratedSecurity = IntegratedSecurity
        ws = New ReportService.ReportingService2005

        'WebserviceURL bestimmen
        If Not WebServiceURL.EndsWith("2005.asmx") Or Not WebServiceURL.EndsWith("2005.asmx?=wsdl") Then 'Hier knnte man um ganz sicher zu gehen auch UPPERCASE URL vergleichen
            If Not WebServiceURL.EndsWith("/") Then
                WebServiceURL = WebServiceURL + "/"
            End If
            WebServiceURL = WebServiceURL + "ReportService2005.asmx"
        End If
        ws.Url = WebServiceURL '+ "/ReportService2005.asmx"

        If Me.WebServiceIntegratedSecurity = False Then
            ws.Credentials = New System.Net.NetworkCredential(Me.WebServiceUsername, Me.WebServicePassword, Me.WebServiceDomain)
        Else 'Windows Integrated Security
            ws.Credentials = System.Net.CredentialCache.DefaultNetworkCredentials
        End If
    End Sub

    Public Function Check() As Boolean
        Dim c As Boolean = False
        Try
            ws.ListJobs()
            c = True
        Catch ex As Exception
            c = False
        End Try
        Return c
    End Function

    Public Function GetFolderAsNodes() As TreeNode
        Dim XRoot As New TreeNode(Me.strWSURL + "/")
        XRoot.Tag = Me
        Return (FillTreeView("/", XRoot))
    End Function

    Public Function GetObjectsByPath(ByVal Path As String) As CatalogItem()
        Dim wsci() As CatalogItem = Nothing
        Try
            wsci = ws.ListChildren(Path, False)
        Catch ex As Exception
        End Try
        Return wsci
    End Function

    Public Function FillTreeView(ByVal Path As String, ByVal ParentNode As TreeNode) As TreeNode
        Dim Items() As CatalogItem = ws.ListChildren(Path, False)
        For Each Item As CatalogItem In Items
            Select Case Item.Type
                Case ItemTypeEnum.Folder
                    Dim SubNode As New TreeNode(Item.Name)
                    SubNode.ImageIndex = 0
                    SubNode.Tag = Item
                    SubNode.Name = Item.Path
                    SubNode.SelectedImageIndex = SubNode.ImageIndex
                    ParentNode.Nodes.Add(FillTreeView(Item.Path, SubNode))
            End Select
        Next
        Return ParentNode
    End Function

End Class
