Public Class frmAddRS

    Private rsReportServer As ReportServer = Nothing

    Public ReadOnly Property ReportServer() As ReportServer
        Get
            Return rsReportServer
        End Get
    End Property

    Private Sub cbWSIS_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbWSIS.CheckedChanged
        Me.txtWSUsername.Enabled = Not Me.cbWSIS.Checked
        Me.txtWSPassword.Enabled = Not Me.cbWSIS.Checked
        Me.txtWSDomain.Enabled = Not Me.cbWSIS.Checked
        'Alte Eingaben lschen
        Me.txtWSDomain.Text = System.Net.CredentialCache.DefaultNetworkCredentials.Domain 'Default Domain
        Me.txtWSPassword.Text = ""
        Me.txtWSUsername.Text = ""

    End Sub


    Private Sub btnAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAdd.Click
        If Check() Then
            Me.rsReportServer = New ReportServer(Me.txtWSURL.Text, Me.cbWSIS.Checked, Me.txtWSUsername.Text, Me.txtWSPassword.Text, Me.txtWSDomain.Text)
            If Me.rsReportServer.Check = True Then
                Me.DialogResult = Windows.Forms.DialogResult.OK
            Else
                Dim sqlMsgBox As New Microsoft.SqlServer.MessageBox.ExceptionMessageBox()
                sqlMsgBox.Text = "The connection could not be established."
                sqlMsgBox.Caption = "RSToolKit Beta"
                sqlMsgBox.ShowToolBar = False
                sqlMsgBox.Buttons = Microsoft.SqlServer.MessageBox.ExceptionMessageBoxButtons.OK
                sqlMsgBox.Symbol = Microsoft.SqlServer.MessageBox.ExceptionMessageBoxSymbol.Error
                sqlMsgBox.HelpLink = "http://rstoolkit.codeplex.com/documentation"
                sqlMsgBox.Beep = True
                sqlMsgBox.Show(Me)
            End If
        End If
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        Me.DialogResult = Windows.Forms.DialogResult.Cancel
    End Sub

    Private Sub frmAddRS_load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        Me.txtWSURL.Text = "http://" & My.Computer.Name.ToString & "/ReportServer"
        Me.txtWSDomain.Text = System.Net.CredentialCache.DefaultNetworkCredentials.Domain 'Default Domain
        Me.txtWSPassword.Text = ""
        Me.txtWSUsername.Text = ""
    End Sub

    Private Function Check() As Boolean
        Dim bRet As Boolean = False
        If Not IsNothing(Me.txtWSURL.Text) And Not Me.txtWSURL.Text = "" Then 'URL Textfeld darf nicht leer sein
            If Me.txtWSURL.Text.Contains("http") And Me.txtWSURL.Text.Contains("://") And Me.txtWSURL.Text.Contains("/") Then 'URL besitzt gltiges Format
                bRet = True
            Else
                MsgBox("Die fr den Report Server angegebene URL besitzt kein gltiges Format.", MsgBoxStyle.Critical, "ReportServer registrieren")
            End If
        Else
            MsgBox("Sie mssen eine URL zum Report Server WebService angeben.", MsgBoxStyle.Critical, "ReportServer registrieren")
        End If
        Return bRet
    End Function

    Private Sub txtWSURL_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles txtWSURL.KeyDown
        If e.KeyData = Keys.Enter Then
            If Check() = True Then
                Me.rsReportServer = New ReportServer(Me.txtWSURL.Text, Me.cbWSIS.Checked, Me.txtWSUsername.Text, Me.txtWSPassword.Text, Me.txtWSDomain.Text)
                If Me.rsReportServer.Check = True Then
                    Me.DialogResult = Windows.Forms.DialogResult.OK
                Else
                    Dim sqlMsgBox As New Microsoft.SqlServer.MessageBox.ExceptionMessageBox()
                    sqlMsgBox.Text = "The connection could not be established."
                    sqlMsgBox.Caption = "RSToolKit Beta"
                    sqlMsgBox.ShowToolBar = False
                    sqlMsgBox.Buttons = Microsoft.SqlServer.MessageBox.ExceptionMessageBoxButtons.OK
                    sqlMsgBox.Symbol = Microsoft.SqlServer.MessageBox.ExceptionMessageBoxSymbol.Error
                    sqlMsgBox.HelpLink = "http://rstoolkit.codeplex.com/documentation"
                    sqlMsgBox.Beep = True
                    sqlMsgBox.Show(Me)
                End If
            End If
        End If
    End Sub

End Class