Imports RSToolKit.ReportService

Public Class frmExplorer_old


#Region " - local variables - "

    ''' <summary>
    ''' Contains all loaded ReportServer objects.
    ''' </summary>
    ''' <remarks></remarks>
    Private RS As New ArrayList
    ''' <summary>
    ''' The currently active ReportServer object.
    ''' </summary>
    ''' <remarks></remarks>
    Private ActualRS As ReportServer
    ''' <summary>
    ''' Contains the currently active folder path.
    ''' </summary>
    ''' <remarks>Set mainly via TreeView SelectedNode</remarks>
    Private strPath As String = Nothing

#End Region

#Region " - enumerations - "

    Private Enum ExportEnum
        XML
        CSV
        IMAGE
        PDF
        HTML4
        HTML3
        MHTML
        EXCEL
        HTMLOWC
    End Enum

#End Region

#Region " - GUI user functions - "


    Private Sub BeendenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BeendenToolStripMenuItem.Click
        Me.Close()
    End Sub

    Private Sub HinzufgenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HinzufgenToolStripMenuItem.Click
        AddServer(FormStartPosition.CenterParent)
    End Sub

    Private Sub tvReportServer_AfterSelect(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles tvReportServer.AfterSelect
        SetActualRS()
    End Sub

    Private Sub SymboleToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SymboleToolStripMenuItem.Click
        SetReportView(View.SmallIcon)
    End Sub

    Private Sub ListeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListeToolStripMenuItem.Click
        SetReportView(View.List)
    End Sub

    Private Sub DetailsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DetailsToolStripMenuItem.Click
        SetReportView(View.Details)
    End Sub

    Private Sub AdobePDFToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvAdobePDF.Click
        Me.Export(ExportEnum.PDF)
    End Sub

    Private Sub MicrosoftExcelToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvExcel.Click
        Me.Export(ExportEnum.EXCEL)
    End Sub

    Private Sub TIFFToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvTIFF.Click
        Me.Export(ExportEnum.IMAGE)
    End Sub

    Private Sub HTML32ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvHTML3.Click
        Me.Export(ExportEnum.HTML3)
    End Sub

    Private Sub HTML40ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvHTML4.Click
        Me.Export(ExportEnum.HTML4)
    End Sub

    Private Sub CSVDateiToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvCSV.Click
        Me.Export(ExportEnum.CSV)
    End Sub

    Private Sub XMLDateiToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvXML.Click
        Me.Export(ExportEnum.XML)
    End Sub

    Private Sub WebArchivToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvWebArchiv.Click
        Me.Export(ExportEnum.MHTML)
    End Sub

    Private Sub HTMLMitOWCToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvHTMLOWC.Click
        Me.Export(ExportEnum.HTMLOWC)
    End Sub

    Private Sub OrdnerToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvOrdner.Click
        CreateFolder(GetActualPath())
    End Sub

    Private Sub LschenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LschenToolStripMenuItem.Click
        RemoveServer()
    End Sub

    Private Sub OrdnerToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tvOrdner.Click
        CreateFolder(GetActualPath())
    End Sub

    Private Sub SymboleToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvSymbole.Click
        SetReportView(View.SmallIcon)
    End Sub

    Private Sub ListeToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvListe.Click
        SetReportView(View.List)
    End Sub

    Private Sub DetailsToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvDetails.Click
        SetReportView(View.Details)
    End Sub

    Private Sub lvDatasource_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvDatasource.Click
        CreateDataSource_MsgBox()
    End Sub

    Private Sub tvDataSource_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tvDataSource.Click
        CreateDataSource_MsgBox()
    End Sub

    Private Sub SQLServerReportToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SQLServerReportToolStripMenuItem1.Click
        CreateReport()
    End Sub

    Private Sub SQLServerReportToolStripMenuItem_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SQLServerReportToolStripMenuItem.Click
        CreateReport()
    End Sub

    Private Sub SnapshotErstellenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvSnapshot.Click
        For Each n As ListViewItem In Me.lvReports.SelectedItems
            CreateSnapShot(n.Tag)
        Next
    End Sub



    Private Sub ReportDefinitionLanguageXMLSchemaToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ReportDefinitionLanguageXMLSchemaToolStripMenuItem1.Click
        Try
            Dim frmwb As New frmBrowser
            frmwb.URL = Me.ActualRS.WebServiceURL & "/reportdefinition.xsd"
            frmwb.ShowDialog()
        Catch ex As Exception
            ShowException("You must connect to a ReportServer", ex)
        End Try
    End Sub

    Private Sub InfoToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles InfoToolStripMenuItem.Click
        Dim frmIF As New frmInfo
        frmIF.ShowDialog()
    End Sub

    Private Sub ToolStripButton2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbAddServer.Click
        AddServer(FormStartPosition.CenterParent)
    End Sub

    Private Sub ToolStripButton3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbRemoveServer.Click
        RemoveServer()
    End Sub

    Private Sub BerichtsManagerToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BerichtsManagerToolStripMenuItem.Click
        Try
            If Not IsNothing(Me.ActualRS) Then
                Dim x As String = Me.ActualRS.WebServiceURL & "/ReportBuilder/ReportBuilder.application"
                Process.Start(x)
            Else
                ShowInformation("You have to connect to at least one SSRS instance to be able to use the Report Builder feature.")
            End If
        Catch ex As Exception
            ShowException("An error occured.", ex)
        End Try
    End Sub

    Private Sub ToolStripButton4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Try
            Me.lvReports.Items.Clear()
            Me.lvReports.Items.AddRange(Search(Me.txtSearch.Text))
        Catch ex As Exception
            ShowException("An error occured.", ex)
        End Try
    End Sub

    Private Sub ToolStripButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbRefresh.Click
        Me.UpdateTV()
        'Me.tvReportServer.ExpandAll()
        Me.UpdateLV()
    End Sub

    Private Sub EigenschaftenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvEigenschaften.Click
        Dim frmProperties As New frmProperties
        frmProperties.CatalogItem = Me.lvReports.SelectedItems(0).Tag
        frmProperties.ReportServer = Me.ActualRS
        If frmProperties.ShowDialog() = Windows.Forms.DialogResult.OK Then
            Me.UpdateLV()
        End If
    End Sub

    Private Sub SQLServerReportToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvSQLRS.Click
        For Each lv As ListViewItem In Me.lvReports.SelectedItems
            Dim ci As CatalogItem = lv.Tag
            ExportAsRDL(ci)
        Next
    End Sub

    Private Sub tvLoeschen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tvLoeschen.Click
        If Me.tvReportServer.SelectedNode.Tag.ToString = "RSToolKit.ReportServer" Then
            'TODO: Use dialog with information symbol
            MsgBox("Der Report Server kann nicht gelscht werden." & vbNewLine & "Sie knnen ber Datei -> ReportServer die Registrierung des ausgewhlten ReportServers entfernen.", MsgBoxStyle.Information, "ReportServer")
        Else
            'TODO: Use dialog with questionmark symbol
            If MsgBox("Do you really want to delete the whole content of this folder?" & vbNewLine & "All elements inside of the folder will be deleted.", MsgBoxStyle.YesNo, "Delete node") = MsgBoxResult.Yes Then
                Dim ci As CatalogItem = Me.tvReportServer.SelectedNode.Tag
                If DeleteItem(ci.Path) Then
                    Me.UpdateTV()
                End If
            End If
        End If
    End Sub

    Private Sub lvLoeschen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvLoeschen.Click
        'TODO: Use dialog with questionmark symbol (or warning)
        If MsgBox("Do you really want to delete the selected objects?" & vbNewLine & "The selected elements will be deleted permamently.", MsgBoxStyle.YesNo, "Delete elements") = MsgBoxResult.Yes Then
            For Each n As ListViewItem In Me.lvReports.SelectedItems
                Dim ci As CatalogItem = n.Tag
                Try
                    DeleteItem(ci.Path)
                Catch ex As Exception
                    ShowException("An error occured while deleting elements.", ex)
                End Try
            Next
            Me.UpdateLV()
        End If
    End Sub

#End Region

#Region " - GUI functions - "

    Private Sub ShowException(ByVal Text As String, Optional ByVal ExceptionText As Exception = Nothing)
        Dim sqlMsgBox As New Microsoft.SqlServer.MessageBox.ExceptionMessageBox()
        sqlMsgBox.Text = Text
        sqlMsgBox.Caption = "RSToolKit Beta"
        sqlMsgBox.ShowToolBar = True
        sqlMsgBox.Buttons = Microsoft.SqlServer.MessageBox.ExceptionMessageBoxButtons.OK
        sqlMsgBox.Symbol = Microsoft.SqlServer.MessageBox.ExceptionMessageBoxSymbol.Error
        sqlMsgBox.HelpLink = "http://rstoolkit.codeplex.com/documentation"
        If Not IsNothing(ExceptionText) Then
            sqlMsgBox.InnerException = ExceptionText
        End If
        sqlMsgBox.Beep = True
        sqlMsgBox.Show(Me)
    End Sub

    Private Sub ShowInformation(ByVal Text As String, Optional ByVal Caption As String = Nothing)
        Dim sqlMsgBox As New Microsoft.SqlServer.MessageBox.ExceptionMessageBox()
        sqlMsgBox.Text = Text
        sqlMsgBox.ShowToolBar = False
        sqlMsgBox.Buttons = Microsoft.SqlServer.MessageBox.ExceptionMessageBoxButtons.OK
        sqlMsgBox.Symbol = Microsoft.SqlServer.MessageBox.ExceptionMessageBoxSymbol.Information
        sqlMsgBox.HelpLink = "http://rstoolkit.codeplex.com/documentation"
        If Not IsNothing(Caption) Then
            sqlMsgBox.Caption = Caption
        Else
            sqlMsgBox.Caption = "RSToolKit Beta"
        End If
        sqlMsgBox.Beep = True
        sqlMsgBox.Show(Me)
    End Sub

    Private Sub UpdateTV()
        Me.tvReportServer.BeginUpdate()
        Dim selectedFolderIsExpanded As Boolean = False
        If Not (Me.tvReportServer.SelectedNode Is Nothing) Then
            selectedFolderIsExpanded = tvReportServer.SelectedNode.IsExpanded
        End If
        Me.tvReportServer.Nodes.Clear()
        For Each tempRS As ReportServer In RS
            Try
                Me.tvReportServer.Nodes.Add(tempRS.GetFolderAsNodes)
            Catch ex As Exception
                ShowException("An error occured while updating elements", ex)
            End Try
        Next
        'Keep item selected
        If Not (Me.tvReportServer.SelectedNode Is Nothing) Then
            tvReportServer.SelectedNode.EnsureVisible()
            If selectedFolderIsExpanded Then
                tvReportServer.SelectedNode.Expand()
            End If
        Else
            If (tvReportServer.Nodes.Find(strPath, True).Length = 1) And Not strPath Is Nothing Then
                tvReportServer.SelectedNode = tvReportServer.Nodes.Find(strPath, True)(0)
                tvReportServer.SelectedNode.EnsureVisible()
                If selectedFolderIsExpanded Then
                    tvReportServer.SelectedNode.Expand()
                End If
            End If
        End If
        Me.tvReportServer.EndUpdate()
    End Sub

    Private Sub UpdateLV()
        Try
            Me.lvReports.Items.Clear()
            For Each Item As CatalogItem In ActualRS.GetObjectsByPath(strPath)
                'If Not Item.Type = ItemTypeEnum.Folder Then
                Me.lvReports.Items.Add(GetItemAsListViewItem(Item))
                'End If
            Next
        Catch ex As Exception
            'ShowException("An error occured while updating elements", ex)
        End Try
    End Sub

    Private Sub tv_ContextMenue(ByVal sender As Object, ByVal e As EventArgs) Handles cmsTreeView.Opened
        Try
            If IsNothing(Me.tvReportServer.SelectedNode.Index.ToString) Then
            End If
            Me.tvDataSource.Enabled = True
            Me.tvKopieren.Enabled = True
            Me.tvLoeschen.Enabled = True
            Me.tvNeu.Enabled = True
            Me.tvOrdner.Enabled = True
            Me.tvUmbenennen.Enabled = True
            Me.tvVerschieben.Enabled = True
        Catch ex As Exception
            Me.tvDataSource.Enabled = False
            Me.tvKopieren.Enabled = False
            Me.tvLoeschen.Enabled = False
            Me.tvNeu.Enabled = False
            Me.tvOrdner.Enabled = False
            Me.tvUmbenennen.Enabled = False
            Me.tvVerschieben.Enabled = False
        End Try
    End Sub

    Private Sub Item_ContextMenu(ByVal sender As Object, ByVal e As EventArgs) Handles cmsListView.Opened
        If Me.lvReports.SelectedItems.Count > 0 Then
            Dim ci As CatalogItem = Me.lvReports.SelectedItems(0).Tag
            Select Case ci.Type
                Case ItemTypeEnum.Report, ItemTypeEnum.LinkedReport
                    Me.lvOffline.Enabled = True
                    Me.lvUmbenennen.Enabled = True
                    Me.lvLoeschen.Enabled = True
                    Me.lvVerschieben.Enabled = True
                    Me.lvEigenschaften.Enabled = True
                    Me.lvKopieren.Enabled = True
                    Me.lvSnapshot.Enabled = True
                    Me.lvPreview.Enabled = True
                    Me.RDLViewerToolStripMenuItem.Enabled = True
                Case ItemTypeEnum.Folder
                    Me.lvUmbenennen.Enabled = True
                    Me.lvLoeschen.Enabled = True
                    Me.lvVerschieben.Enabled = True
                    Me.lvEigenschaften.Enabled = True
                    Me.lvKopieren.Enabled = True
                    Me.lvSnapshot.Enabled = False
                    Me.lvPreview.Enabled = False
                    Me.RDLViewerToolStripMenuItem.Enabled = False
                    Me.lvOffline.Enabled = False
                Case Else
                    Me.lvOffline.Enabled = False
                    Me.lvSnapshot.Enabled = False
                    Me.lvPreview.Enabled = False
                    Me.RDLViewerToolStripMenuItem.Enabled = False
            End Select
        Else
            Me.lvOffline.Enabled = False
            Me.lvUmbenennen.Enabled = False
            Me.lvLoeschen.Enabled = False
            Me.lvVerschieben.Enabled = False
            Me.lvEigenschaften.Enabled = False
            Me.lvKopieren.Enabled = False
            Me.lvSnapshot.Enabled = False
            Me.RDLViewerToolStripMenuItem.Enabled = False
        End If
    End Sub

#End Region

#Region " - Helper - "

    Private Function GetMasterNode(ByVal Node As TreeNode) As TreeNode
        Dim myNode As New TreeNode
        If Not Node.Parent Is Nothing Then
            myNode = GetMasterNode(Node.Parent)
        Else
            myNode = Node
        End If
        Return myNode
    End Function

    Private Function GetParentPath(ByVal currentPath As String) As String
        Dim delimiter As String = "/"
        Dim rx As New System.Text.RegularExpressions.Regex(delimiter)
        Dim childPath As String() = rx.Split(currentPath)
        Dim parentLength As Integer = childPath.Length - 1
        Dim parentPath(parentLength) As String
        Dim i As Integer
        For i = 0 To parentLength - 1
            parentPath(i) = childPath(i)
        Next i
        Select Case parentPath.Length
            Case 1, 2
                Return "/"
            Case Else
                Return String.Join("/", parentPath).TrimEnd("/")
        End Select
    End Function

    Private Function GetNameFromPath(ByVal path As String) As String
        Dim ary As String() = path.TrimStart("/").Split("/")
        Return ary(ary.GetUpperBound(0))
    End Function

    Private Function IsExist(ByVal item As CatalogItem, ByVal TheRS As ReportingService2005) As Boolean
        Dim condition As New RSToolKit.ReportService.SearchCondition
        Dim conditions(0) As SearchCondition
        condition.Condition = ConditionEnum.Equals
        condition.ConditionSpecified = True
        condition.Name = "Name"
        condition.Value = item.Name
        conditions(0) = condition
        Dim foundItems As CatalogItem() = TheRS.FindItems(GetParentPath(item.Path), BooleanOperatorEnum.And, conditions)
        Dim tArray As New ArrayList(foundItems)
        For i As Int16 = foundItems.GetUpperBound(0) To 0 Step -1
            If foundItems(i).Path <> item.Path Then
                tArray.RemoveAt(i)
            End If
        Next
        Select Case tArray.Count
            Case 0
                Return False
            Case 1
                Return True
            Case Else
                Return True
        End Select
    End Function

#End Region

#Region " - Report Server Funktionen - "

    Private Sub AddServer(Optional ByVal StartPosition As Windows.Forms.FormStartPosition = FormStartPosition.CenterParent)
        Try
            Dim frmAdd As New frmAddRS
            frmAdd.StartPosition = StartPosition
            If frmAddRS.ShowDialog = Windows.Forms.DialogResult.OK Then
                RS.Add(frmAddRS.ReportServer)
                UpdateTV()
            End If
        Catch ex As Exception
            ShowException("An error occured while connecting to the specified report server.", ex)
        End Try
    End Sub

    Private Sub RemoveServer()
        Me.RS.Remove(Me.ActualRS)
        UpdateTV()
    End Sub

    Private Function GetItemAsListViewItem(ByVal Item As CatalogItem) As ListViewItem
        Dim li As New ListViewItem
        If Item.Hidden = True Then
            li.ForeColor = Color.Red
        End If
        li.Text = Item.Name
        li.Tag = Item
        Select Case Item.Type
            Case ItemTypeEnum.DataSource
                li.ImageIndex = 1
                li.SubItems.Add("DataSource")
                li.SubItems.Add("")
            Case ItemTypeEnum.LinkedReport
                li.ImageIndex = 2
                li.SubItems.Add("Linked Report")
                li.SubItems.Add(FormatNumber(Item.Size / 1024, 2).ToString + " KB")
            Case ItemTypeEnum.Report
                li.ImageIndex = 2
                li.SubItems.Add("Report")
                li.SubItems.Add(FormatNumber(Item.Size / 1024, 2).ToString + " KB")
            Case ItemTypeEnum.Resource
                li.ImageIndex = 2
                li.SubItems.Add("Resource")
                li.SubItems.Add(FormatNumber(Item.Size / 1024, 2).ToString + " KB")
            Case ItemTypeEnum.Unknown
                li.ImageIndex = 2
                li.SubItems.Add("Unknown")
                li.SubItems.Add(FormatNumber(Item.Size / 1024, 2).ToString + " KB")
            Case ItemTypeEnum.Folder
                li.ImageIndex = 0
                li.SubItems.Add("Folder")
                li.SubItems.Add("")
        End Select
        li.SubItems.Add(Item.CreatedBy)
        li.SubItems.Add(Item.CreationDate)
        li.SubItems.Add(Item.ModifiedDate)
        li.SubItems.Add(Item.ModifiedBy)
        Return li
    End Function

    Private Function Search(ByVal Text As String) As ListViewItem()
        Dim items As CatalogItem() = Nothing
        Dim condition As New SearchCondition()
        condition.Condition = ConditionEnum.Contains
        condition.ConditionSpecified = True
        condition.Name = "Name"
        condition.Value = Text
        Dim conditions(0) As SearchCondition
        conditions(0) = condition
        items = Me.ActualRS.ws.FindItems("/", BooleanOperatorEnum.Or, conditions)
        Dim lvi(items.Length - 1) As ListViewItem
        If Not (items Is Nothing) Then
            Dim j As Integer = 0
            For i As Integer = 0 To items.Length - 1
                If Not items(i).Type = ItemTypeEnum.Folder Then
                    lvi(j) = (GetItemAsListViewItem(items(i)))
                    j += 1
                End If
            Next
        End If
        Return lvi
    End Function

    Private Sub Render(ByVal Item As CatalogItem, ByVal ExportFormat As ExportEnum)
        If Item.Type = ItemTypeEnum.Report Then
            Try
                Dim strFormat As String = Nothing
                Select Case ExportFormat
                    Case ExportEnum.CSV
                        Me.sfExport.Filter = "CSV-File (*.csv)|.csv"
                        strFormat = "CSV"
                    Case ExportEnum.EXCEL
                        Me.sfExport.Filter = "Microsoft Excel (*.xls)|.xls"
                        strFormat = "EXCEL"
                    Case ExportEnum.HTMLOWC
                        Me.sfExport.Filter = "HTML Office Web Components (*.html)|.html"
                        strFormat = "HTMLOWC"
                    Case ExportEnum.PDF
                        Me.sfExport.Filter = "Adobe Acrobat (*.pdf)|.pdf"
                        strFormat = "PDF"
                    Case ExportEnum.XML
                        Me.sfExport.Filter = "XML-File (*.xml)|.xml"
                        strFormat = "XML"
                    Case ExportEnum.IMAGE
                        Me.sfExport.Filter = "Image (*.tiff)|.tiff"
                        strFormat = "IMAGE"
                    Case ExportEnum.MHTML
                        Me.sfExport.Filter = "Web-Archive (*.mhtml)|.mhtml"
                        strFormat = "MHTML"
                    Case ExportEnum.HTML3
                        Me.sfExport.Filter = "HTML 3.2 (*.html)|.html"
                        strFormat = "HTML3.2"
                    Case ExportEnum.HTML4
                        Me.sfExport.Filter = "HTML 4.0 (*.html)|.html"
                        strFormat = "HTML4.0"
                End Select
                Me.sfExport.FileName = ""
                If Me.sfExport.ShowDialog = Windows.Forms.DialogResult.OK Then
                    Dim results() As Byte = Nothing
                    'results = Me.ActualRS.ws.Render(Item.Path, strFormat, Nothing, "", Nothing, Nothing, "", "", "", Nothing, Nothing, Nothing)
                    Dim stream As System.IO.FileStream = System.IO.File.OpenWrite(Me.sfExport.FileName)
                    stream.Write(results, 0, results.Length)
                    stream.Close()
                End If
            Catch ex As Exception
                Dim sqlMsgBox As New Microsoft.SqlServer.MessageBox.ExceptionMessageBox()
                sqlMsgBox.Text = "An error occured while trying to export elements."
                sqlMsgBox.Caption = "RSToolKit Beta"
                sqlMsgBox.ShowToolBar = True
                sqlMsgBox.Symbol = Microsoft.SqlServer.MessageBox.ExceptionMessageBoxSymbol.Error
                sqlMsgBox.Beep = True
                sqlMsgBox.Show(Me)
            End Try
        Else
            Dim sqlMsgBox As New Microsoft.SqlServer.MessageBox.ExceptionMessageBox()
            sqlMsgBox.Text = "You can only export report items."
            sqlMsgBox.Caption = "RSToolKit Beta"
            sqlMsgBox.ShowToolBar = True
            sqlMsgBox.Symbol = Microsoft.SqlServer.MessageBox.ExceptionMessageBoxSymbol.Error
            sqlMsgBox.Beep = True
            sqlMsgBox.Show(Me)
        End If
    End Sub

#End Region

    ''' <summary>
    ''' Keeps track of the currently active (selected) folder and ReportServer
    ''' </summary>
    ''' <remarks>Always setting Node.Tag after select, even when ActualRS is unchanged, may be a bit slow</remarks>
    Private Sub SetActualRS()
        If Me.tvReportServer.SelectedNode.Tag.ToString = "RSToolKit.ReportServer" Then
            strPath = "/"
            Me.ActualRS = Me.tvReportServer.SelectedNode.Tag
        Else
            strPath = Me.tvReportServer.SelectedNode.Name
            Me.ActualRS = GetMasterNode(Me.tvReportServer.SelectedNode).Tag
        End If
        txtCurrentPath.Text = Me.ActualRS.WebServiceURL.Replace("ReportServer", "Reports") + strPath
        UpdateLV()
    End Sub

    Private Sub Export(ByVal ExportFormat As ExportEnum)
        For Each n As ListViewItem In Me.lvReports.SelectedItems
            Dim CI As CatalogItem = n.Tag
            If CI.Type = ItemTypeEnum.Report Or CI.Type = ItemTypeEnum.LinkedReport Then
                Try
                    Render(CI, ExportFormat)
                Catch ex As Exception
                    ShowException("An error occured while exporting a report", ex)
                End Try
            End If
        Next
    End Sub

    Private Function GetActualPath() As String
        Dim Path As String = Nothing
        If Me.tvReportServer.SelectedNode.Tag.ToString = "RSToolKit.ReportServer" Then
            Path = "/"
            Me.ActualRS = Me.tvReportServer.SelectedNode.Tag
        Else
            Dim ci As CatalogItem = Me.tvReportServer.SelectedNode.Tag
            Path = ci.Path
        End If
        Return Path
    End Function

    Private Sub CreateFolder(ByVal Path As String)
        Dim frmNO As New frmNewFolder
        frmNO.Pfad = Path
        If frmNO.ShowDialog = Windows.Forms.DialogResult.OK Then
            Me.ActualRS.ws.CreateFolder(frmNO.txtOrdner.Text, Path, Nothing)
            Me.UpdateTV()
        End If
    End Sub

    Private Function DeleteItem(ByVal Path As String) As Boolean
        Dim bRet As Boolean = False
        Try
            Me.ActualRS.ws.DeleteItem(Path)
            bRet = True
        Catch ex As Exception
            bRet = False
        End Try
        Return bRet
    End Function

    Private Sub tvUmbenennen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tvUmbenennen.Click
        If Not Me.tvReportServer.SelectedNode.Tag.ToString = "RSToolKit.ReportServer" Then
            Dim ci As CatalogItem = Me.tvReportServer.SelectedNode.Tag
            Dim frmUB As New frmRename
            Dim strPfad As String = ci.Path.Substring(0, ci.Path.LastIndexOf("/") + 1)
            Dim strOldName As String = ci.Path.Substring(ci.Path.LastIndexOf("/") + 1, ci.Path.Length - (ci.Path.LastIndexOf("/") + 1))
            frmUB.Pfad = strPfad
            frmUB.OldName = strOldName
            If frmUB.ShowDialog = Windows.Forms.DialogResult.OK Then
                Try
                    Me.ActualRS.ws.MoveItem(strPfad + strOldName, strPfad + frmUB.NewObjectName)
                    Me.UpdateTV()
                Catch ex As Exception
                    Dim sqlMsgBox As New Microsoft.SqlServer.MessageBox.ExceptionMessageBox()
                    sqlMsgBox.Text = "An error occured while trying to rename an element."
                    sqlMsgBox.Caption = "RSToolKit Beta"
                    sqlMsgBox.ShowToolBar = True
                    sqlMsgBox.Symbol = Microsoft.SqlServer.MessageBox.ExceptionMessageBoxSymbol.Error
                    sqlMsgBox.Beep = True
                    sqlMsgBox.Show(Me)
                End Try
            End If
        End If
    End Sub

    Private Sub tvVerschieben_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tvVerschieben.Click
        If Me.tvReportServer.SelectedNode.Tag.ToString = "RSToolKit.ReportServer" Then
            ShowException("It is not possible to move a ReportServer")
        Else
            Dim ci As CatalogItem = Me.tvReportServer.SelectedNode.Tag
            Dim frmV As New frmMove
            Dim strPfad As String = ci.Path.Substring(0, ci.Path.LastIndexOf("/") + 1)
            Dim strOldName As String = ci.Path.Substring(ci.Path.LastIndexOf("/") + 1, ci.Path.Length - (ci.Path.LastIndexOf("/") + 1))
            For Each node As TreeNode In Me.tvReportServer.Nodes
                frmV.Add(node.Tag)
            Next
            'frmV.ReportServer = Me.ActualRS
            If frmV.ShowDialog = Windows.Forms.DialogResult.OK Then
                Try
                    Dim GPath As String = Nothing
                    If Not IsNothing(frmV.Item) Then GPath = frmV.Item.Path
                    Me.ActualRS.ws.MoveItem(strPfad + strOldName, GPath + "/" + strOldName)
                    Me.UpdateTV()
                Catch ex As Exception
                    ShowException("An error occured while moving elements", ex)
                End Try
            End If
        End If
    End Sub

    Private Sub ExportAsRDL(ByVal Item As CatalogItem)
        Dim rpt As Byte()
        Me.sfExport.Filter = "SQL Server Report (*.rpt)|*.rpt|SQL Server Report (*.rdl)|*.rdl"
        Me.sfExport.FileName = ""
        If Me.sfExport.ShowDialog = Windows.Forms.DialogResult.OK Then
            rpt = Me.ActualRS.ws.GetReportDefinition(Item.Path)
            My.Computer.FileSystem.WriteAllBytes(Me.sfExport.FileName, rpt, False)
        End If
    End Sub

    Private Sub SetReportView(ByVal View As System.Windows.Forms.View)
        Me.lvReports.View = View
        'determine checkstate for context menu
        lvDetails.Checked = False
        lvSymbole.Checked = False
        lvListe.Checked = False

        If View = Windows.Forms.View.Details Then
            lvDetails.Checked = True
        ElseIf View = Windows.Forms.View.SmallIcon Then
            lvSymbole.Checked = True
        ElseIf View = Windows.Forms.View.List Then
            lvListe.Checked = True
        End If
    End Sub

    Private Sub CreateSnapShot(ByVal Item As CatalogItem)
        If Item.Type = ItemTypeEnum.Report Or Item.Type = ItemTypeEnum.LinkedReport Then
            Try
                Me.ActualRS.ws.CreateReportHistorySnapshot(Item.Path, Nothing)
            Catch ex As Exception
                ShowException("An error occured while creating a snapshot.", ex)
            End Try
        End If
    End Sub

    Public Sub CreateDataSource_MsgBox()
        Dim frmDS As New frmDataSource
        If frmDS.ShowDialog = Windows.Forms.DialogResult.OK Then
            If Me.CreateDataSource(frmDS.ConnectionString, frmDS.WindowsAuthentication, frmDS.Benutzername, frmDS.Password, frmDS.DataSourceName, frmDS.Overwrite) = True Then
                UpdateLV()
            Else

            End If
        End If
    End Sub

    Public Function CreateDataSource(ByVal ConnectionString As String, _
                                    ByVal WindowsAuthentication As Boolean, _
                                    ByVal Benutzername As String, _
                                    ByVal Password As String, _
                                    ByVal DatasourceName As String, _
                                    ByVal Overwrite As Boolean) As Boolean
        Dim DSD As New RSToolKit.ReportService.DataSourceDefinition()
        DSD.ConnectString = ConnectionString
        If WindowsAuthentication Then
            DSD.WindowsCredentials = True
        Else
            DSD.UserName = Benutzername
            DSD.Password = Password
            DSD.WindowsCredentials = False

        End If
        DSD.Extension = "SQL"
        DSD.Enabled = True
        DSD.EnabledSpecified = True
        DSD.ImpersonateUserSpecified = True
        DSD.Prompt = Nothing
        Me.ActualRS.ws.CreateDataSource(DatasourceName, Me.strPath, Overwrite, DSD, Nothing)
    End Function

    Public Function CreateDataSource(ByVal DataSourceDefinition As RSToolKit.ReportService.DataSourceDefinition, _
                                ByVal DatasourceName As String, _
                                ByVal Overwrite As Boolean) As Boolean
        Me.ActualRS.ws.CreateDataSource(DatasourceName, Me.strPath, Overwrite, DataSourceDefinition, Nothing)
    End Function

    Public Sub CreateReport()
        Dim frmNR As New frmNewReport
        If frmNR.ShowDialog = Windows.Forms.DialogResult.OK Then
            Dim definition As [Byte]() = Nothing
            Dim name As String = Nothing
            Dim stream As System.IO.FileStream
            name = frmNR.ReportName
            stream = System.IO.File.OpenRead(frmNR.Filename)
            definition = New [Byte](stream.Length) {}
            stream.Read(definition, 0, CInt(stream.Length))
            stream.Close()
            Me.ActualRS.ws.CreateReport(name, Me.strPath, frmNR.Overwrite, definition, Nothing)
            Me.UpdateLV()
        End If
    End Sub

    Public Sub Upload()
        If Me.ofdUpload.ShowDialog = Windows.Forms.DialogResult.OK Then
            Dim badFiles As New ArrayList()
            For Each Files As String In Me.ofdUpload.FileNames
                Dim file As New System.IO.FileInfo(Files)

                Dim name As String = Replace(file.Name, file.Extension, "")
                Select Case file.Extension
                    Case ".rdl"
                        Try
                            Dim definition As [Byte]() = Nothing
                            Dim stream As System.IO.FileStream
                            stream = System.IO.File.OpenRead(file.FullName)
                            definition = New [Byte](stream.Length) {}
                            stream.Read(definition, 0, CInt(stream.Length))
                            stream.Close()
                            Me.ActualRS.ws.CreateReport(name, Me.strPath, True, definition, Nothing)
                        Catch ex As Exception
                            badFiles.Add(name)
                        End Try
                    Case ".rds"
                        Try
                            Dim doc As New Xml.XmlDocument
                            doc.Load(file.FullName)
                            Dim dds As New RSToolKit.ReportService.DataSourceDefinition()
                            For Each node As Xml.XmlNode In doc.ChildNodes
                                dds.ConnectString = node("ConnectionString").ToString
                                dds.Extension = node("Extension").ToString
                            Next
                        Catch ex As Exception
                            badFiles.Add(file.FullName)
                        End Try
                    Case Else
                        badFiles.Add(file.FullName)
                End Select

                Me.UpdateLV()
            Next
            Dim sqlMsgBox As New Microsoft.SqlServer.MessageBox.ExceptionMessageBox()
            sqlMsgBox.Text = "Errors occured during upload of elements:" & vbNewLine & vbNewLine
            For i As Integer = 0 To badFiles.Count - 1
                sqlMsgBox.Text += badFiles(i) & vbNewLine
            Next
            sqlMsgBox.Caption = "RSToolKit Beta"
            sqlMsgBox.ShowToolBar = True
            sqlMsgBox.Symbol = Microsoft.SqlServer.MessageBox.ExceptionMessageBoxSymbol.Error
            sqlMsgBox.Beep = True
            sqlMsgBox.Show(Me)
        End If
    End Sub

    Private Sub lvUmbenennen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvUmbenennen.Click
        Dim ci As CatalogItem = Me.lvReports.SelectedItems(0).Tag
        Dim frmUB As New frmRename
        Dim strPfad As String = ci.Path.Substring(0, ci.Path.LastIndexOf("/") + 1)
        Dim strOldName As String = ci.Path.Substring(ci.Path.LastIndexOf("/") + 1, ci.Path.Length - (ci.Path.LastIndexOf("/") + 1))
        frmUB.Pfad = strPfad
        frmUB.OldName = strOldName
        If frmUB.ShowDialog = Windows.Forms.DialogResult.OK Then
            Try
                Me.ActualRS.ws.MoveItem(strPfad + strOldName, strPfad + frmUB.NewObjectName)
                Me.UpdateLV()
            Catch ex As Exception
                ShowException("An error occured while renaming elements", ex)
            End Try
        End If
    End Sub

    Private Sub lvVerschieben_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvVerschieben.Click
        Dim frmV As New frmMove
        For Each node As TreeNode In Me.tvReportServer.Nodes
            frmV.Add(node.Tag)
        Next
        If frmV.ShowDialog = Windows.Forms.DialogResult.OK Then
            Try
                For Each lvi As ListViewItem In Me.lvReports.SelectedItems
                    Dim ci As CatalogItem = lvi.Tag
                    Dim strPfad As String = ci.Path.Substring(0, ci.Path.LastIndexOf("/") + 1)
                    Dim strOldName As String = ci.Path.Substring(ci.Path.LastIndexOf("/") + 1, ci.Path.Length - (ci.Path.LastIndexOf("/") + 1))
                    Dim strNewName As String = ci.Path.Substring(ci.Path.LastIndexOf("/") + 1, ci.Path.Length - (ci.Path.LastIndexOf("/") + 1))
                    Dim TheReportServer As ReportServer = frmV.ReportServer
                    Dim tempCI As New CatalogItem
                    tempCI.Path = frmV.Item.Path + "/" + strOldName
                    tempCI.Name = strOldName
                    While IsExist(tempCI, TheReportServer.ws)
                        strNewName = "Copy of " + tempCI.Name
                        tempCI.Name = "Copy of " + tempCI.Name
                        tempCI.Path = frmV.Item.Path + "/" + strNewName
                    End While
                    Me.ActualRS.ws.MoveItem(strPfad + strOldName, frmV.Item.Path + "/" + strNewName)
                Next
                Me.UpdateLV()
            Catch ex As Exception
                ShowException("An error occured while moving elements", ex)
            End Try
        End If
    End Sub

    Private Sub lvKopieren_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvKopieren.Click

        'Populate TreeView of Dialog with FolderNodes
        Dim frmV As New frmMove
        For Each node As TreeNode In Me.tvReportServer.Nodes
            frmV.Add(node.Tag)
        Next
        frmV.Copy = True 'Form properties (Copy/Move)

        If frmV.ShowDialog = Windows.Forms.DialogResult.OK Then
            For Each lvi As ListViewItem In Me.lvReports.SelectedItems

                Dim ci As CatalogItem = lvi.Tag 'current item
                Dim DestinationServer As ReportServer = frmV.ReportServer
                Dim DestFolder As String = frmV.Item.Path
                If IsNothing(DestFolder) Then
                    DestFolder = "/"
                End If

                Try
                    CopyItem(DestinationServer, ci, DestFolder)

                Catch ex As Exception
                    ShowException("An error occured while copying elements", ex)
                    Me.UpdateLV()
                End Try
            Next
            Me.UpdateLV()
        End If
    End Sub

    Private Sub CopyItem(ByVal DestinationServer As ReportServer, ByVal SourceObject As CatalogItem, ByVal DestFolder As String)
        Dim ci As CatalogItem = SourceObject

        Dim newPath As String = DestFolder
        Dim name As String = ci.Name

        'Rename object if an object with same name exists
        Dim tempCI As New CatalogItem
        tempCI.Path = DestFolder + "/" + name
        tempCI.Name = name

        While IsExist(tempCI, DestinationServer.ws)
            tempCI.Name = "Copy of " + name
            tempCI.Path = DestFolder + "/" + tempCI.Name
        End While
        name = tempCI.Name

        Select Case ci.Type
            Case ItemTypeEnum.Report
                Dim definition As [Byte]() = Nothing
                definition = Me.ActualRS.ws.GetReportDefinition(ci.Path)
                DestinationServer.ws.CreateReport(name, newPath, True, definition, Nothing)
                DestinationServer.ws.SetProperties(newPath + "/" + name, GetPropsFromObject(ci))
            Case ItemTypeEnum.DataSource
                Dim definition As RSToolKit.ReportService.DataSourceDefinition = Nothing
                definition = Me.ActualRS.ws.GetDataSourceContents(ci.Path)
                DestinationServer.ws.CreateDataSource(name, newPath, True, definition, Nothing)
                'Apply enhanced attributes (like hidden flag, description etc.) of the original to the new element
                DestinationServer.ws.SetProperties(newPath + "/" + name, GetPropsFromObject(ci))
            Case ItemTypeEnum.Folder
                DestinationServer.ws.CreateFolder(name, newPath, Nothing)

                If DestFolder = "/" Then
                    DestFolder = DestFolder + name
                Else
                    DestFolder = DestFolder + "/" + name
                End If

                'Apply enhanced attributes (like hidden flag, description etc.) of the original to the new folder
                DestinationServer.ws.SetProperties(DestFolder, GetPropsFromObject(ci))

                'Take care of possible SubItems
                Dim subItems As CatalogItem()
                subItems = ActualRS.GetObjectsByPath(ci.Path) 'Get content of the newly created folder
                For Each nci As CatalogItem In subItems
                    CopyItem(DestinationServer, nci, DestFolder)
                Next
            Case ItemTypeEnum.LinkedReport
                ShowException("Copying LinkedReports is not yet implemented.")
            Case ItemTypeEnum.Model
                Dim definition As [Byte]() = Nothing
                definition = Me.ActualRS.ws.GetModelDefinition(ci.Path)
                DestinationServer.ws.CreateModel(name, newPath, definition, Nothing)
                DestinationServer.ws.SetProperties(newPath + "/" + name, GetPropsFromObject(ci))
            Case ItemTypeEnum.Resource
                Dim definition As [Byte]() = Nothing
                definition = Me.ActualRS.ws.GetResourceContents(ci.Path, ci.MimeType)
                DestinationServer.ws.CreateResource(name, newPath, True, definition, ci.MimeType, Nothing)
                DestinationServer.ws.SetProperties(newPath + "/" + name, GetPropsFromObject(ci))
                'Case ItemTypeEnum.Unknown
                '    ShowException("Copy is not implemented yet for unknown Objects.")
            Case Else
                ShowException("Unsupported Object")
        End Select
    End Sub

    ''' <summary>
    ''' Collects all properties of an CatalogItem and returns them as array for use with RS.ws.SetProperties()
    ''' </summary>
    ''' <param name="ci">Source CatalogItem</param>
    ''' <returns>Array containing all Type specific properties of ci</returns>
    ''' <remarks></remarks>
    Private Function GetPropsFromObject(ByVal ci As CatalogItem) As [Property]()
        Dim propl As New List(Of [Property])

        Select Case ci.Type
            Case ItemTypeEnum.Folder
                propl.Add(AsProp("Description", ci.Description))
                propl.Add(AsProp("Hidden", ci.Hidden))
            Case Else
                propl.Add(AsProp("Description", ci.Description))
                propl.Add(AsProp("Hidden", ci.Hidden))
        End Select

        Return propl.ToArray()
    End Function

    Private Function AsProp(ByVal key As String, ByVal value As String) As [Property]
        Dim p As New [Property]
        p.Name = key
        p.Value = value
        Return p
    End Function

    Private Sub EigenschaftenToolStripMenuItem_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EigenschaftenToolStripMenuItem.Click
        Try
            If Me.tvReportServer.SelectedNode.Tag.ToString = "RSToolKit.ReportServer" Then
                'ShowException("Server properties can not be displayed (yet).")
                Dim frmSP As New frmServerProperties
                frmSP.ReportServer = ActualRS
                frmSP.ShowDialog()
            Else
                Dim frmProperties As New frmProperties
                'TODO: betroffenes CatalogItem vor Aufrufen des Dialogs aktualisieren (Frisch vom Server auschecken)
                frmProperties.CatalogItem = Me.tvReportServer.SelectedNode.Tag
                frmProperties.ReportServer = Me.ActualRS
                If frmProperties.ShowDialog() = Windows.Forms.DialogResult.OK Then
                    Me.UpdateLV()
                End If
            End If
        Catch ex As Exception
            ShowException("You must connect to a report server.", ex)
        End Try
    End Sub

    Private Sub UploadToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UploadToolStripMenuItem.Click
        Upload()
    End Sub

    Private Sub RSToolKitHomepageToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RSToolKitHomepageToolStripMenuItem.Click
        'Open the RSToolkit homepage with systems default webbrowser
        Process.Start("http://rstoolkit.codeplex.com")
    End Sub

    Private Sub tvReportServer_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles tvReportServer.DragDrop
        'Check that there is a TreeNode being dragged
        If e.Data.GetDataPresent("System.Windows.Forms.TreeNode", True) = False Then Exit Sub

        'Get the TreeView raising the event (incase multiple on form)
        Dim selectedTreeview As TreeView = CType(sender, TreeView)

        'Get the TreeNode being dragged
        Dim dropNode As TreeNode = CType(e.Data.GetData("System.Windows.Forms.TreeNode"), TreeNode)

        'The target node should be selected from the DragOver event
        Dim targetNode As TreeNode = selectedTreeview.SelectedNode

        'Let user confirm move action here
        Dim dr As DialogResult
        dr = MessageBox.Show(String.Format("Move Folder '{0}' to '{1}'?", CType(dropNode.Tag, CatalogItem).Path, CType(targetNode.Tag, CatalogItem).Path), "Move Folder", MessageBoxButtons.OKCancel, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2)

        If dr = Windows.Forms.DialogResult.OK Then
            'If there is no targetNode add dropNode to the bottom of
            'the TreeView root nodes, otherwise add it to the end of
            'the dropNode child nodes

            If dropNode.Tag.ToString = "RSToolKit.ReportServer" Then
                ShowException("You cannot move a report server.")
            Else
                If Not targetNode Is Nothing Then
                    Try
                        Dim ciOld As CatalogItem = dropNode.Tag
                        Dim NewPath As String = Nothing
                        Dim strOldName As String = Nothing

                        If Not targetNode.Tag.ToString() = "RSToolKit.ReportServer" Then
                            Dim ciNew As CatalogItem = (targetNode.Tag)
                            NewPath = ciNew.Path
                        Else
                            NewPath = "/" 'Move to RootFolder
                        End If

                        strOldName = ciOld.Path.Substring(ciOld.Path.LastIndexOf("/") + 1, ciOld.Path.Length - (ciOld.Path.LastIndexOf("/") + 1))
                        Me.ActualRS.ws.MoveItem(ciOld.Path, NewPath + "/" + strOldName)

                        'TODO: Cleanup (find proper ways of updating too)

                        'Remove the drop node from its current location
                        'dropNode.Remove()

                        'Update Path Property to new value for current folder and all subfolders
                        'does not update subfolders so i disabled it again....
                        'Dim cidrop As CatalogItem = dropNode.Tag
                        'cidrop.Path = NewPath + "/" + strOldName
                        'dropNode.Tag = cidrop

                        ''Its a bit buggy so i disabled it again
                        'selectedTreeview.BeginUpdate()
                        'Dim parentNode As TreeNode = targetNode.Parent
                        'Dim targetindex As Integer = parentNode.Index
                        'parentNode.Nodes.Remove(targetNode)
                        'selectedTreeview.Nodes.Remove(targetNode)
                        'targetNode = Me.ActualRS.FillTreeView(NewPath + "/" + strOldName, targetNode)
                        'parentNode.Nodes.Add(targetNode)
                        'selectedTreeview.EndUpdate()

                        ''dropNode.EnsureVisible()
                        'targetNode.EnsureVisible()
                        'selectedTreeview.SelectedNode = dropNode
                        UpdateTV()
                    Catch ex As Exception
                        ShowException("An error has occurred.", ex)
                    End Try
                Else

                End If
            End If

        End If

    End Sub

    Private Sub tvReportServer_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles tvReportServer.DragEnter
        If e.Data.GetDataPresent("System.Windows.Forms.TreeNode", True) Then
            e.Effect = DragDropEffects.Move
        Else
            e.Effect = DragDropEffects.None
        End If
    End Sub

    Private Sub tvReportServer_DragOver(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles tvReportServer.DragOver
        'Check that there is a TreeNode being dragged 
        If e.Data.GetDataPresent("System.Windows.Forms.TreeNode", True) = False Then Exit Sub

        'Get the TreeView raising the event (incase multiple on form)
        Dim selectedTreeview As TreeView = CType(sender, TreeView)

        'As the mouse moves over nodes, provide feedback to 
        'the user by highlighting the node that is the 
        'current drop target
        Dim pt As Point = _
            CType(sender, TreeView).PointToClient(New Point(e.X, e.Y))
        Dim targetNode As TreeNode = selectedTreeview.GetNodeAt(pt)

        'See if the targetNode is currently selected, 
        'if so no need to validate again
        If Not (selectedTreeview.SelectedNode Is targetNode) Then
            'Select the    node currently under the cursor
            selectedTreeview.SelectedNode = targetNode

            'Check that the selected node is not the dropNode and
            'also that it is not a child of the dropNode and 
            'therefore an invalid target
            Dim dropNode As TreeNode = CType(e.Data.GetData("System.Windows.Forms.TreeNode"), TreeNode)

            Do Until targetNode Is Nothing
                If targetNode Is dropNode Then
                    e.Effect = DragDropEffects.None
                    Exit Sub
                End If
                targetNode = targetNode.Parent
            Loop

            'Currently selected node is a suitable target
            e.Effect = DragDropEffects.Move

        End If

    End Sub

    Private Sub tvReportServer_ItemDrag(ByVal sender As Object, ByVal e As System.Windows.Forms.ItemDragEventArgs) Handles tvReportServer.ItemDrag
        DoDragDrop(e.Item, DragDropEffects.Move)
    End Sub

    Private Sub LicenseToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LicenseToolStripMenuItem.Click
        frmLicense.ShowDialog()
    End Sub

    ''' <summary>
    ''' This Sub handles HotKey (Shortcut) functions for the ListView
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e">Contains information about the pressed key</param>
    ''' <remarks>Prepared but not finished yet</remarks>
    Private Sub lvReports_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles lvReports.KeyDown
        If lvReports.SelectedItems.Count > 0 Then 'Selected items must exist in the ListView
            'Is only one item selected? renaming multiple objects at once is not possible
            If lvReports.SelectedItems.Count = 1 Then
                Select Case e.KeyCode
                    Case Keys.F2
                        'MsgBox("Rename action for object: " & lvReports.SelectedItems(0).Text) 'Debug Box
                        'TODO: add code to actually rename the element (windows explorer style would be splendid but preparing and showing the rename dialog should be enough)
                End Select
            Else
                'Do nothing, showing an eror message like "you cannot rename multiple objects at once" would be annoying, wouldn't it? (ME)
            End If

        End If

    End Sub

    Private Sub lvPreview_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvPreview.Click
        If Me.lvReports.SelectedItems.Count > 0 Then
            Dim frmPreview As New frmPreview
            Dim n As ListViewItem = Me.lvReports.SelectedItems(0)
            Dim CI As CatalogItem = n.Tag
            If CI.Type = ItemTypeEnum.Report Or CI.Type = ItemTypeEnum.LinkedReport Then
                frmPreview.Report = CI.Path
                frmPreview.ReportServer = New Uri(Me.ActualRS.WebServiceURL)
                frmPreview.ShowDialog()
            End If
        Else
            ShowInformation("You must select a report first to be able to preview it.")
        End If
    End Sub

    Private Sub RDLViewerToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RDLViewerToolStripMenuItem.Click
        If Me.lvReports.SelectedItems.Count > 0 Then
            Dim frmRDL As New frmShowRDL
            Dim n As ListViewItem = Me.lvReports.SelectedItems(0)
            Dim CI As CatalogItem = n.Tag
            If CI.Type = ItemTypeEnum.Report Or CI.Type = ItemTypeEnum.LinkedReport Then
                frmRDL.Report = CI.Path
                frmRDL.CatalogItem = CI
                frmRDL.Server = ActualRS
                frmRDL.ShowDialog()
            End If
        Else
            ShowInformation("You must select a report file first to be able to views its definition.")
        End If
    End Sub

    Private Sub tvKopieren_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tvKopieren.Click
        'Populate TreeView of Dialog with FolderNodes
        Dim frmV As New frmMove
        For Each node As TreeNode In Me.tvReportServer.Nodes
            frmV.Add(node.Tag)
        Next
        frmV.Copy = True 'Form properties (Copy/Move)

        If frmV.ShowDialog = Windows.Forms.DialogResult.OK Then

            Dim ci As CatalogItem = tvReportServer.SelectedNode.Tag 'current item
            Dim DestinationServer As ReportServer = frmV.ReportServer
            Dim DestFolder As String = frmV.Item.Path
            If IsNothing(DestFolder) Then
                DestFolder = "/"
            End If

            Try
                CopyItem(DestinationServer, ci, DestFolder)

            Catch ex As Exception
                ShowException("An error occured while copying elements", ex)
                Me.UpdateTV()
            End Try

            Me.UpdateTV()
        End If
    End Sub
    ''' <summary>
    ''' If the user doubleclicked a folder item in ListView this EventHandler will navigate there.
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e">MouseEventArgs</param>
    ''' <remarks></remarks>
    Private Sub lvReports_MouseDoubleClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles lvReports.MouseDoubleClick
        Dim ciCurrent As CatalogItem = lvReports.SelectedItems(0).Tag
        'Debug Messagebox
        'MessageBox.Show(String.Format("Doubleclicked item: {0} of Type {1} at Path {2}", ciCurrent.Name, ciCurrent.Type.ToString(), ciCurrent.Path))
        'MessageBox.Show(tvReportServer.SelectedNode.FullPath)

        'Change current folder to clicked path and refresh
        If ciCurrent.Type = ItemTypeEnum.Folder Then
            'Always has to return 1 single item
            tvReportServer.SelectedNode = tvReportServer.Nodes.Find(ciCurrent.Path, True)(0)
            SetActualRS()
        End If
    End Sub

    Private Sub frmExplorer_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        AddServer(FormStartPosition.CenterScreen)
    End Sub

    Private Sub SToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SToolStripMenuItem.Click
        Try
            If Not Me.txtSearch.Text = "" Then
                Me.lvReports.Items.Clear()
                Me.lvReports.Items.AddRange(Search(Me.txtSearch.Text))
            End If
        Catch ex As Exception
            ShowException("An error occured.", ex)
        End Try
    End Sub

    Private Sub IndexServerToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles IndexServerToolStripMenuItem.Click
        Dim Reindex As New frmReindex
        Reindex.Server = Me.ActualRS
        Reindex.ShowDialog()
    End Sub

End Class