Imports RSToolKit.ReportService

Public Class frmPolicies

    Private CI As CatalogItem
    Private RS As ReportServer

    Public WriteOnly Property ReportServer() As ReportServer
        Set(ByVal value As ReportServer)
            Me.RS = value
        End Set
    End Property

    Public WriteOnly Property Item() As CatalogItem
        Set(ByVal value As CatalogItem)
            Me.CI = value
        End Set
    End Property

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        Me.DialogResult = Windows.Forms.DialogResult.Cancel
    End Sub

    Private Sub btnAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAdd.Click
        Try
            Dim Role(Me.GroupBox1.Controls.Count) As RSToolKit.ReportService.Role
            Dim intC As Integer = 0
            For Each c As Control In Me.GroupBox1.Controls
                If CType(c, System.Windows.Forms.CheckBox).Checked Then
                    Dim setRole As New Role()
                    setRole.Name = CType(c, System.Windows.Forms.CheckBox).Text
                    Role(intC) = setRole
                    intC += 1
                End If
            Next
            If intC = 0 Then
                MsgBox("Sie mssen mindestens eine Rolle fr den Benutzer angeben.", MsgBoxStyle.Critical, "Fehler")
                Exit Sub
            End If
            Dim NewRole(intC - 1) As RSToolKit.ReportService.Role
            For i As Integer = 0 To intC - 1
                NewRole(i) = Role(i)
            Next
            Dim Pol() As RSToolKit.ReportService.Policy
            Pol = Me.RS.ws.GetPolicies(CI.Path, True)

            Dim Policy(Pol.Length) As RSToolKit.ReportService.Policy
            Dim setPolicy As New RSToolKit.ReportService.Policy()

            setPolicy.GroupUserName = Me.txtBenutzername.Text
            setPolicy.Roles = NewRole
            Policy(0) = setPolicy

            For i As Integer = 0 To Pol.Length - 1
                Policy(i + 1) = Pol(i)
            Next

            RS.ws.SetPolicies(CI.Path, Policy)
            Me.DialogResult = Windows.Forms.DialogResult.OK
        Catch ex As Exception
            'MsgBox(ex.ToString)
            MsgBox("Fehler beim Anlegen des Benutzers." & vbNewLine & "Bitte berpfen Sie die Rollen und/oder ob der angegebene Benutzer bereits existiert.", MsgBoxStyle.Critical, "Fehler")
        End Try
    End Sub

    Private Sub frmPolicies_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        txtBenutzername.Select()
        Dim role() As RSToolKit.ReportService.Role
        role = Me.RS.ws.ListRoles(SecurityScopeEnum.All)
        For i As Integer = 0 To role.Length - 1
            Dim cbRoles As System.Windows.Forms.CheckBox
            cbRoles = New System.Windows.Forms.CheckBox
            Me.GroupBox1.Controls.Add(cbRoles)
            cbRoles.AutoSize = True
            cbRoles.Dock = System.Windows.Forms.DockStyle.Top
            cbRoles.Location = New System.Drawing.Point(3, 16)
            cbRoles.Name = "cbRoles" + CType(i, String)
            cbRoles.Size = New System.Drawing.Size(255, 17)
            cbRoles.TabIndex = 0
            cbRoles.Text = role(i).Name
            cbRoles.UseVisualStyleBackColor = True
        Next
    End Sub

End Class